------------------------------------------------------------
-- VHDL Debounce
-- 2012 10 3 23 28 15
-- Created By "DXP VHDL Generator"
-- "Copyright (c) 2002-2004 Altium Limited"
------------------------------------------------------------

------------------------------------------------------------
-- VHDL Debounce
------------------------------------------------------------

Library IEEE;
Use     IEEE.std_logic_1164.all;

--synthesis translate_off
Library GENERIC_LIB;
Use     GENERIC_LIB.all;

--synthesis translate_on
Entity Debounce Is
  port
  (
    CLK1KHZ : In    STD_LOGIC;                               -- ObjectKind=Port|PrimaryId=CLK1KHZ
    CONTACT : In    STD_LOGIC;                               -- ObjectKind=Port|PrimaryId=CONTACT
    OUT     : Out   STD_LOGIC                                -- ObjectKind=Port|PrimaryId=OUT
  );
  attribute MacroCell : boolean;

End Debounce;
------------------------------------------------------------

------------------------------------------------------------
architecture structure of Debounce is
   Component AND2S                                           -- ObjectKind=Part|PrimaryId=U4|SecondaryId=1
      port
      (
        I0 : in  STD_LOGIC;                                  -- ObjectKind=Pin|PrimaryId=U4-I0
        I1 : in  STD_LOGIC;                                  -- ObjectKind=Pin|PrimaryId=U4-I1
        O  : out STD_LOGIC                                   -- ObjectKind=Pin|PrimaryId=U4-O
      );
   End Component;

   Component Configurable_U2                                 -- ObjectKind=Part|PrimaryId=U2|SecondaryId=1
      port
      (
        C   : in  STD_LOGIC;                                 -- ObjectKind=Pin|PrimaryId=U2-C
        CE  : in  STD_LOGIC;                                 -- ObjectKind=Pin|PrimaryId=U2-CE
        CEO : out STD_LOGIC;                                 -- ObjectKind=Pin|PrimaryId=U2-CEO
        CLR : in  STD_LOGIC;                                 -- ObjectKind=Pin|PrimaryId=U2-CLR
        Q   : out STD_LOGIC_VECTOR(7 downto 0);              -- ObjectKind=Pin|PrimaryId=U2-Q[7..0]
        TC  : out STD_LOGIC                                  -- ObjectKind=Pin|PrimaryId=U2-TC
      );
   End Component;

   Component INV                                             -- ObjectKind=Part|PrimaryId=U3|SecondaryId=1
      port
      (
        I : in  STD_LOGIC;                                   -- ObjectKind=Pin|PrimaryId=U3-I
        O : out STD_LOGIC                                    -- ObjectKind=Pin|PrimaryId=U3-O
      );
   End Component;


    Signal NamedSignal_DC     : STD_LOGIC_VECTOR(7 downto 0); -- ObjectKind=Net|PrimaryId=DC[7..0]
    Signal PinSignal_U2_Q     : STD_LOGIC_VECTOR(7 downto 0); -- ObjectKind=Net|PrimaryId=DC[7..0]
    Signal PinSignal_U3_O     : STD_LOGIC; -- ObjectKind=Net|PrimaryId=NetU2_CE
    Signal PinSignal_U4_O     : STD_LOGIC; -- ObjectKind=Net|PrimaryId=NetU3_I
    Signal PinSignal_U5_O     : STD_LOGIC; -- ObjectKind=Net|PrimaryId=NetU4_I1

begin
    U5 : INV                                                 -- ObjectKind=Part|PrimaryId=U5|SecondaryId=1
      Port Map
      (
        I => CONTACT,                                        -- ObjectKind=Pin|PrimaryId=U5-I
        O => PinSignal_U5_O                                  -- ObjectKind=Pin|PrimaryId=U5-O
      );

    U4 : AND2S                                               -- ObjectKind=Part|PrimaryId=U4|SecondaryId=1
      Port Map
      (
        I0 => NamedSignal_DC(7),                             -- ObjectKind=Pin|PrimaryId=U4-I0
        I1 => PinSignal_U5_O,                                -- ObjectKind=Pin|PrimaryId=U4-I1
        O  => PinSignal_U4_O                                 -- ObjectKind=Pin|PrimaryId=U4-O
      );

    U3 : INV                                                 -- ObjectKind=Part|PrimaryId=U3|SecondaryId=1
      Port Map
      (
        I => PinSignal_U4_O,                                 -- ObjectKind=Pin|PrimaryId=U3-I
        O => PinSignal_U3_O                                  -- ObjectKind=Pin|PrimaryId=U3-O
      );

    U2 : Configurable_U2                                     -- ObjectKind=Part|PrimaryId=U2|SecondaryId=1
      Port Map
      (
        C   => CLK1KHZ,                                      -- ObjectKind=Pin|PrimaryId=U2-C
        CE  => PinSignal_U3_O,                               -- ObjectKind=Pin|PrimaryId=U2-CE
        CLR => CONTACT,                                      -- ObjectKind=Pin|PrimaryId=U2-CLR
        Q   => PinSignal_U2_Q                                -- ObjectKind=Pin|PrimaryId=U2-Q[7..0]
      );

    -- Signal Assignments
    ---------------------
    NamedSignal_DC <= PinSignal_U2_Q; -- ObjectKind=Net|PrimaryId=DC[7..0]
    OUT            <= PinSignal_U4_O; -- ObjectKind=Net|PrimaryId=NetU3_I

end structure;
------------------------------------------------------------

